import { bufToImageUrl } from ".";

const worker = new Worker("build/workers/ai-worker.js");

let i = 0;

let cb = {};

worker.addEventListener("message", ev => {
  if (ev.data.i in cb) {
    cb[ev.data.i](ev.data.result);
    delete cb[ev.data.i]
    delete ev.data.i;
  }
})

const analyze = (img: Image) => new Promise((res, rej) => {
  i++;
  const _i = i;

  const canvas = document.createElement("canvas");
  canvas.width = img.width;
  canvas.height = img.height;

  const cx = canvas.getContext("2d");
  const image = document.createElement("img");
  image.onload = () => {

    cx.drawImage(image, 0, 0);
    const pixels = cx.getImageData(0, 0, image.width, image.height).data

    worker.postMessage({ i: _i, pixels, width: img.width, height: img.height });
  }

  image.src = bufToImageUrl(img.data, img.type);


  cb[_i] = res;
});

export default { analyze }